// BenchMapView.cpp : CBenchMapView NX̎
//

#include "stdafx.h"
#include "BenchMap.h"

#include "BenchMapDoc.h"
#include "CntrItem.h"
#include "BenchMapView.h"


#include "MapClasses.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBenchMapView

IMPLEMENT_DYNCREATE(CBenchMapView, CRichEditView)

BEGIN_MESSAGE_MAP(CBenchMapView, CRichEditView)
	ON_WM_DESTROY()
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, &CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CRichEditView::OnFilePrintPreview)
	ON_COMMAND(ID_BENCH_MAP, &CBenchMapView::OnBenchMap)
	ON_WM_CREATE()
END_MESSAGE_MAP()

// CBenchMapView RXgNV/fXgNV

CBenchMapView::CBenchMapView()
{
	// TODO: \zR[hɒǉ܂B

}

CBenchMapView::~CBenchMapView()
{
}

BOOL CBenchMapView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CRichEditView::PreCreateWindow(cs);
}

void CBenchMapView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();


	// ̗]ݒ肵܂ (720 twips = 1/2 inch).
	SetMargins(CRect(720, 720, 720, 720));
}


// CBenchMapView 

BOOL CBenchMapView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ̈
	return DoPreparePrinting(pInfo);
}


void CBenchMapView::OnDestroy()
{
	// ŎɃACeANeBx[g܂; ͕r[
	// gpĂꍇɂ͏dvłB
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
   CRichEditView::OnDestroy();
}

int CBenchMapView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CRichEditView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ɓȍ쐬R[hǉĂB
	CHARFORMAT cf;
	GetRichEditCtrl().GetDefaultCharFormat(cf);
	cf.yHeight = static_cast<int>(cf.yHeight * 0.8);
    ::_tcscpy_s(cf.szFaceName, _T("lr SVbN"));
	BOOL b = GetRichEditCtrl().SetDefaultCharFormat(cf);

	return 0;
}


// CBenchMapView ff

#ifdef _DEBUG
void CBenchMapView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CBenchMapView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CBenchMapDoc* CBenchMapView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBenchMapDoc)));
	return (CBenchMapDoc*)m_pDocument;
}
#endif //_DEBUG


// CBenchMapView bZ[W nh

void CBenchMapView::OnBenchMap()
{

	struct{
		CMapBase::BENCHFUNC	func;
		TCHAR				*sText;
	}static const f[] = {
		{&CMapBase::BenchInsert,	_T("Insert")	},
		{&CMapBase::BenchFind,		_T("Find")		},
	};
	for(int i=0; i<(sizeof(f)/sizeof(*f)); i++ ){

		CMap_map		map;
		CMap_hash_map	hash_map;
		CMap_CMap		cmap;
		CMap_CMap1009	cmap1009;
		std::vector<CMapBase*> arymap;
		arymap.push_back(&map);
		arymap.push_back(&hash_map);
		arymap.push_back(&cmap);
		arymap.push_back(&cmap1009);
		{
			CString s;
			GetRichEditCtrl().ReplaceSel( CString(_T("\xd\xa")) +  f[i].sText );
			s.Format(_T("\xd\xa%20s,"),_T("vf"));
			for(std::vector<CMapBase*>::iterator im=arymap.begin(); im!=arymap.end(); im++ ){
				s.Format(_T("%s%20s,"),CString(s),(*im)->GetName());
			}
			GetRichEditCtrl().ReplaceSel(s);
		}

		static const int t[]={
#ifdef _DEBUG
			3,5,10
#else
			3,5,10,20,50,100,200,500,1000,2000,5000,10000,20000,50000,100000
#endif
		};
		for(int j=0; j<(sizeof(t)/sizeof(*t)); j++ ){
			const int nSize = t[j];

			std::vector<std::string> arykey;
			{
				for(int i=0; i<nSize; i++ ){
					CString sKey;
					sKey.Format(_T("%x-%x"),rand(),rand());
					std::string s(sKey);
					arykey.push_back(s);
				}
			}

			CString s;
			s.Format(_T("\xd\xa%20d,"),nSize);
			{
				for(std::vector<CMapBase*>::iterator im=arymap.begin(); im!=arymap.end(); im++ ){
					int nResult = ((*im)->*(f[i].func))(arykey);
					s.Format(_T("%s%20d,"),CString(s),nResult);
				}
			}
			GetRichEditCtrl().ReplaceSel(s);

		}

	}

}

